package com.logopartner.customization;

import java.awt.Point;
import java.awt.Rectangle;

import com.lbs.controls.JLbsComboEdit;
import com.lbs.controls.JLbsControlHelper;
import com.lbs.data.objects.CustomBusinessObject;
import com.lbs.remoteclient.IClientContext;
import com.lbs.transport.RemoteMethodResponse;
import com.lbs.xui.JLbsXUILookupInfo;
import com.lbs.xui.customization.JLbsXUIControlEvent;
import com.logopartner.util.FormUtil;
import com.logopartner.util.ProjectGlobals;

public class DoctorEditHandler
{

	public JLbsComboEdit cmbProficiency;

	public DoctorEditHandler()
	{
		super();
	}

	public void onKeyPressed(JLbsXUIControlEvent event)
	{
		FormUtil.checkForComboClear(event, "PROFICIENCYREF", "Proficiency", 210);
	}

	public void onLookup(JLbsXUIControlEvent event)
	{
		try
		{
			CustomBusinessObject doctor = (CustomBusinessObject) event.getData();			
			CustomBusinessObject codeObj = (CustomBusinessObject) doctor.get("Proficiency");
			if (codeObj == null)
				codeObj = new CustomBusinessObject();
			JLbsXUILookupInfo lookup = new JLbsXUILookupInfo();
			lookup.setQueryParamValue("P_TYPE", new Integer(MedicalConstants.CODE_DOCTORTYPE));
			Rectangle r = JLbsControlHelper.getRootCoordinates(cmbProficiency);
			FormUtil.displayBrowser(event.getClientContext(), event.getContainer(), 
            		"Forms/MedCodesBrowser.lfrm", lookup, new Point(r.x, r.y + r.height), true);
            if (lookup.getIntegerData("LOGICALREF") != 0)
            {
            	event.getContainer().setModified(true);
            	doctor.set("PROFICIENCYREF", lookup.getIntegerData("LOGICALREF"));
            	codeObj.set("DESCRIPTION", lookup.getStringData("DESCRIPTION"));
            	doctor.set("Proficiency", codeObj);
            	FormUtil.updateComponentData(event.getContainer(), 210);
            }			
		} 
		catch (Exception e)
		{
		}
	}

	public void onGetFormVariableValue(JLbsXUIControlEvent event)
	{
		int index = event.getIndex();
		if(index == 1) // dorusu bu
		{
			event.setReturnObject(new Integer(10));
		}
	}

	public void onSaveData(JLbsXUIControlEvent event)
	{
		IClientContext context = event.getContainer().getContext();
		Object[] parameters = new Object[]{new Integer(1)};
		try {
			context.requestBatchOperation("DoctorProfUpdate", parameters);
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public void onInitialize(JLbsXUIControlEvent event)
	{
		IClientContext context = event.getClientContext();
		RemoteMethodResponse response = null;
		try {
			response = context.callRemoteMethod(
						"CRS",  // Registered service name, must always be CRS
						"invokeMethod", // Registered service method, must always be invokeMethod
						new Object[] {
							null, // must always be first parameter and null
							ProjectGlobals.getProjectGUID()+ "." + "com.acme.services.CustomServices", 
							"selectResult",  // name of the method which will be inside the 5. line name of class
							new Object[] {"deneme", "aman" }, // Object array of 6. line method parameters
							null // return parameters must be null and must be the last parameter 
						}
					);

		Object[] results = (Object[]) response.Result;
		if(results!=null&&results.length >=2 )
			System.out.println("Response Result: " + results[0] + " "+ results[1]);
		else
			System.out.println("Remote Method response is wrong");
				
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
