package com.logopartner.customization;

import com.lbs.data.objects.CustomBusinessObject;
import com.lbs.xui.customization.JLbsXUIControlEvent;
import com.lbs.xui.customization.JLbsXUIModuleActionEvent;
import com.logopartner.util.FormUtil;

public class MedicalCodesBrowserHandler
{
	private int m_CodeType = -1;
	
	public void onModifyModuleAction(JLbsXUIModuleActionEvent event)
	{
		try
		{
			switch (event.getModuleAction().getActionId())
			{
			case 5000002: m_CodeType = MedicalConstants.CODE_DOCTORTYPE; break; 
			case 5000003: m_CodeType = MedicalConstants.CODE_VISITTYPE; break;
			}
		}
		catch (Exception e)
		{
		}
		FormUtil.setQueryParams(event, "P_TYPE", new Integer(m_CodeType));
	}
	
	public void onBusinessObjectInit(JLbsXUIControlEvent event)
	{
		try
		{
			CustomBusinessObject obj = (CustomBusinessObject) event.getData();
			obj.set("CODETYPE", m_CodeType);
		} 
		catch (Exception e)
		{
		}
	}

	public void onInitialize(JLbsXUIControlEvent event)
	{
		// If the form is launched not from the navigation tree, but from another window.
		// In this case, onModifyModuleAction is not executed and we need to get the type
		// from the query parameters. 
		if (m_CodeType == -1)
			m_CodeType = FormUtil.getQueryParamInt(event, "P_TYPE", 0);
		switch (m_CodeType)
		{
		case 1: event.getContainer().setTitle("Visit Types");
		}
	}
	
}
