package com.logopartner.customization;

import java.awt.Point;
import java.awt.Rectangle;
import java.util.GregorianCalendar;

import com.lbs.controls.JLbsComboEdit;
import com.lbs.controls.JLbsControlHelper;
import com.lbs.data.objects.CustomBusinessObject;
import com.lbs.xui.JLbsXUILookupInfo;
import com.lbs.xui.customization.JLbsXUIControlEvent;
import com.logopartner.util.FormUtil;
import com.logopartner.util.ProjectUtil;

public class PatientVisitEditHandler
{
	public JLbsComboEdit cmbPatient;
	public JLbsComboEdit cmbType;

	public void onInitialize(JLbsXUIControlEvent event)
	{
		if (FormUtil.isNewObject(event))
		{
			FormUtil.setDataProperty(event, "VISITDATE", GregorianCalendar.getInstance());
			FormUtil.updateComponentData(event.getContainer(), 200);
		}
	}

	public void onKeyPressed(JLbsXUIControlEvent event)
	{
		FormUtil.checkForComboClear(event, "PATIENTREF", "Patient", 210);  
	}

	public void onLookup(JLbsXUIControlEvent event)
	{
		try
		{
			CustomBusinessObject doctor = (CustomBusinessObject) event.getData();			
			CustomBusinessObject codeObj = (CustomBusinessObject) doctor.get("Patient");
			if (codeObj == null)
				codeObj = new CustomBusinessObject();
			JLbsXUILookupInfo lookup = new JLbsXUILookupInfo();
			Rectangle r = JLbsControlHelper.getRootCoordinates(cmbPatient);
			FormUtil.displayBrowser(event.getClientContext(), event.getContainer(), 
            		"Forms/PatientBrowser.lfrm", lookup, new Point(r.x, r.y + r.height), true);
            if (lookup.getIntegerData("LOGICALREF") != 0)
            {
            	event.getContainer().setModified(true);
            	doctor.set("PATIENTREF", lookup.getIntegerData("LOGICALREF"));
            	codeObj.set("CODE", lookup.getStringData("CODE"));
            	codeObj.set("NAME", lookup.getStringData("NAME"));
            	codeObj.set("SURNAME", lookup.getStringData("SURNAME"));
            	doctor.set("Patient", codeObj);
            	FormUtil.updateComponentData(event.getContainer(), 210);
            	FormUtil.updateComponentData(event.getContainer(), 211);
            	FormUtil.updateComponentData(event.getContainer(), 212);
            }			
		} 
		catch (Exception e)
		{
		}
	}

	public void onCmbTypeLookup(JLbsXUIControlEvent event)
	{
		try
		{
			CustomBusinessObject doctor = (CustomBusinessObject) event.getData();			
			CustomBusinessObject codeObj = (CustomBusinessObject) doctor.get("VType");
			if (codeObj == null)
				codeObj = new CustomBusinessObject();
			JLbsXUILookupInfo lookup = new JLbsXUILookupInfo();
			lookup.setQueryParamValue("P_TYPE", new Integer(MedicalConstants.CODE_VISITTYPE));
			Rectangle r = JLbsControlHelper.getRootCoordinates(cmbType);
			FormUtil.displayBrowser(event.getClientContext(), event.getContainer(), 
            		"Forms/MedCodesBrowser.lfrm", lookup, new Point(r.x, r.y + r.height), true);
            if (lookup.getIntegerData("LOGICALREF") != 0)
            {
            	event.getContainer().setModified(true);
            	doctor.set("VISITTYPE", lookup.getIntegerData("LOGICALREF"));
            	codeObj.set("CODE", lookup.getStringData("CODE"));
            	doctor.set("VType", codeObj);
            	FormUtil.updateComponentData(event.getContainer(), 220);
            }			
		} 
		catch (Exception e)
		{
		}
	}

	public void onCmbTypeKeyPressed(JLbsXUIControlEvent event)
	{
		FormUtil.checkForComboClear(event, "VISITTYPE", "VType", 220);
	}

	public void onSaveData(JLbsXUIControlEvent event)
	{
		try
		{
			CustomBusinessObject doctor = (CustomBusinessObject) event.getData();			
			CustomBusinessObject codeObj = (CustomBusinessObject) doctor.get("Patient");
			if (codeObj == null)
			{
				ProjectUtil.warn(event, "A Patient record must be selected to continue!");
				event.setReturnObject(Boolean.FALSE);
            }			
		} 
		catch (Exception e)
		{
		}		
	}

}
