package com.logopartner.customization;

import com.lbs.controls.JLbsImageButton;
import com.lbs.data.factory.FactoryParams;
import com.lbs.data.factory.IObjectFactory;
import com.lbs.data.grids.JLbsQueryGrid;
import com.lbs.data.objects.CustomBusinessObject;
import com.lbs.data.query.QueryBusinessObject;
import com.lbs.util.QueryUtil;
import com.lbs.xui.JLbsXUITypes;
import com.lbs.xui.customization.JLbsXUIControlEvent;
import com.logopartner.util.FormUtil;
import com.logopartner.util.ProjectUtil;

public class PatientVisitsBrowserHandler
{

	public JLbsImageButton btnExamination;
	public JLbsQueryGrid grdData;

	public void onBtnExaminationClick(JLbsXUIControlEvent event)
	{
		try
		{
			QueryBusinessObject selected = (QueryBusinessObject) grdData.getSelectedObject();
			int ref = (selected != null) ? QueryUtil.getIntProp(selected, "LOGICALREF") : 0;
			if (ref == 0)
			{
				ProjectUtil.warn(event, "A Patient visit record must be selected to continue!");
				return;
			}
			CustomBusinessObject visit = FormUtil.createCustomObject("BOPatientVisit");
			FactoryParams params = new FactoryParams();
            IObjectFactory factory = event.getClientContext().getObjectFactory(); 
            params.setRequestLock(true);
            boolean ok = factory.read(visit, params, ref);
            if (!ok)
            {
				ProjectUtil.warn(event, "The patient visit record could not be read.");
				return;
            }
            try
            {
            	CustomBusinessObject diag = (CustomBusinessObject) visit.get("Examination");
            	if (diag == null)
            	{
            		diag = FormUtil.createCustomObject("BOExamination");
            		visit.set("Examination", diag);
            	}
            	if (FormUtil.displayForm(event.getClientContext(), event.getContainer(), 
            			"Forms/ExaminationEdit.lfrm", visit, true) == JLbsXUITypes.XUIOP_PERSISTED)
            	{
    				ProjectUtil.warn(event, "The patient examination has been saved.");
    				return;
            	}
            }
            catch (Exception ex)
            {
            }            
            factory.releaseLock(params, visit.getLockIdTemplate(), visit.getLockId());
		} catch (Exception e)
		{
		}
	}
}
