package com.logopartner.util;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;

import com.lbs.appobjects.GOConstants;
import com.lbs.appobjects.LbsUserLoginInfo;
import com.lbs.controls.menu.JLbsPopupMenuItem;
import com.lbs.data.factory.DBError;
import com.lbs.data.factory.DBErrors;
import com.lbs.data.objects.CustomBusinessObject;
import com.lbs.data.query.QueryBusinessObject;
import com.lbs.dialog.JLbsMessageDialog;
import com.lbs.dialog.JLbsMessageDialogResult;
import com.lbs.globalization.ILbsCultureInfo;
import com.lbs.globalization.JLbsCurrenciesBase;
import com.lbs.globalization.JLbsCurrencyInfo;
import com.lbs.globalization.JLbsDefaultCultureInfo;
import com.lbs.mi.defs.ModuleAction;
import com.lbs.remoteclient.IClientContext;
import com.lbs.util.JLbsConstants;
import com.lbs.util.JLbsStringList;
import com.lbs.xui.JLbsXUIDefinition;
import com.lbs.xui.JLbsXUIForm;
import com.lbs.xui.JLbsXUILookupInfo;
import com.lbs.xui.JLbsXUIPane;
import com.lbs.xui.JLbsXUIProp;
import com.lbs.xui.JLbsXUITypes;
import com.lbs.xui.customization.JLbsXUIControlEvent;
import com.lbs.xui.customization.JLbsXUIModuleActionEvent;

public class FormUtil
{
	public static boolean setActionParams(JLbsXUIModuleActionEvent event,
			String paramName, Object value)
	{
		return setActionParamsInternal(event, new String[]
		{ paramName }, new Object[]
		{ value }, false);
	}

	public static boolean setActionParams(JLbsXUIModuleActionEvent event,
			String[] paramNames, Object[] values)
	{
		return setActionParamsInternal(event, paramNames, values, false);
	}

	public static boolean setQueryParams(JLbsXUIModuleActionEvent event,
			String paramName, Object value)
	{
		return setActionParamsInternal(event, new String[]
		{ paramName }, new Object[]
		{ value }, true);
	}

	public static boolean setQueryParams(JLbsXUIModuleActionEvent event,
			String[] paramNames, Object[] values)
	{
		return setActionParamsInternal(event, paramNames, values, true);
	}

	private static boolean setActionParamsInternal(
			JLbsXUIModuleActionEvent event, String[] paramNames,
			Object[] values, boolean queryParams)
	{
		if (event == null || paramNames == null || values == null
				|| values.length != paramNames.length)
			return false;
		ModuleAction action = event.getModuleAction();
		try
		{
			action.setDataClass("#lookup");

			if (queryParams)
				action.setQueryParamValues(ProjectUtil.formListArray(
						paramNames, values));
			else
				action.setParamValues(ProjectUtil.formListArray(paramNames,
						values));
			event.setReturnObject(action);
			return true;

		} catch (Exception e)
		{
			e.printStackTrace();
		}
		return false;
	}

	public static int getCompanyReference(IClientContext context)
	{
		try
		{
			LbsUserLoginInfo userLoginInfo;
			userLoginInfo = (LbsUserLoginInfo) context
					.getVariable(GOConstants.ms_UserInfo);
			return userLoginInfo.getFirm().getLogicalRef();
		} catch (Exception e)
		{
		}
		return 1;
	}

	public static int getIntProperty(JLbsXUIDefinition xuiDef, int prpType)
	{
		if (xuiDef != null)
		{
			int index = xuiDef.indexOfProp(prpType);
			if (index >= 0)
			{
				JLbsXUIProp prop = xuiDef.getProperty(index);
				if (prop != null)
					try
					{
						return Integer.parseInt(prop.getValue());
					} catch (Exception e)
					{
					}
			}
		}
		return 0;
	}

	public static int displayForm(IClientContext context,
			JLbsXUIPane container, String xuiFormName, Object dataObj, Point p,
			boolean isCustom)
	{
		return displayForm(context, container, xuiFormName, dataObj, true,
				JLbsXUITypes.XUIMODE_DBENTRY, p, isCustom);
	}

	public static int displayForm(IClientContext context,
			JLbsXUIPane container, String xuiFormName, Object dataObj,
			boolean isCustom)
	{
		return displayForm(context, container, xuiFormName, dataObj, true,
				JLbsXUITypes.XUIMODE_DBENTRY, null, isCustom);
	}

	public static int displayForm(IClientContext context,
			JLbsXUIPane container, String xuiFormName, Object dataObj,
			boolean modal, boolean isCustom)
	{
		return displayForm(context, container, xuiFormName, dataObj, modal,
				JLbsXUITypes.XUIMODE_DBENTRY, null, isCustom);
	}

	public static int displayForm(IClientContext context,
			JLbsXUIPane container, String xuiFormName, Object dataObj,
			boolean modal, int displayMode, Point p, boolean isCustom)
	{
		try
		{
			if (isCustom)
				xuiFormName = ProjectGlobals.getProjectGUID() + "."
						+ xuiFormName;
			JLbsXUIForm form = new JLbsXUIForm(context, null, container
					.getCulture(), container.getCurrencies(), container
					.getUserRights(), container.getDBAuthorizations(),
					xuiFormName, dataObj, null, container.getFilterHandler(),
					modal, displayMode, -1, p, false, displayMode, displayMode); 
			p = normalizePoint((Component) form.getContent().getParentComponent(), p);
			form.doDisplay(p);
			return form.getDataState();
		} catch (Exception e)
		{
			return JLbsXUITypes.XUIOP_UNKNOWN;
		}
	}

	private static Point normalizePoint(Component c, Point p)
	{
		try
		{
			Point result = new Point(p);
			Dimension scrSize = Toolkit.getDefaultToolkit().getScreenSize();
			if (result.x + c.getWidth() > scrSize.width)
				result.x = scrSize.width - c.getWidth() - 4;
			if (result.y + c.getHeight() > scrSize.height)
				result.y = scrSize.height - c.getHeight() - 4;

			if (result.x < 0)
				result.x = 0;
			if (result.y < 0)
				result.y = 0;
			return result;
		} catch (Exception e)
		{
		}
		return p;
	}

	public static int displayBrowser(IClientContext context,
			JLbsXUIPane container, String xuiFormName, Object dataObj, Point p,
			boolean isCustom)
	{
		return displayForm(context, container, xuiFormName, dataObj, true,
				JLbsXUITypes.XUIMODE_DBSELECT, p, isCustom);
	}

	public static int displayBrowser(IClientContext context,
			JLbsXUIPane container, String xuiFormName, Object dataObj,
			boolean isCustom)
	{
		return displayForm(context, container, xuiFormName, dataObj, true,
				JLbsXUITypes.XUIMODE_DBSELECT, null, isCustom);
	}

	public static int displayBrowser(IClientContext context,
			JLbsXUIPane container, String xuiFormName, Object dataObj,
			boolean modal, boolean isCustom)
	{
		return displayForm(context, container, xuiFormName, dataObj, modal,
				JLbsXUITypes.XUIMODE_DBSELECT, null, isCustom);
	}

	public static boolean popupCheckEnabled(JLbsPopupMenuItem item,
			JLbsXUIPane container, Object data, IClientContext context, int iTag)
	{
		QueryBusinessObject object = container.getSelectedGridData(100);
		switch (iTag)
		{
		case 2:
		case 3:
		case 4:
		case 5:
		case 7:
			if (object == null)
				return false;
			break;
		}
		return true;
	}

	public static void processDBErrors(JLbsXUIPane container, DBErrors errors,
			boolean clearFlag)
	{
		DBError error;

		if (clearFlag)
			container.clearPaneMessages();

		for (int i = 0; i < errors.size(); i++)
		{
			error = (DBError) errors.get(i);
			String errorMsg = error.getMessage();
			int type = JLbsXUITypes.MT_ERROR;
			container.addPaneMessage(type, error.getID(), errorMsg, 0, 0);
		}
	}

	public static JLbsMessageDialogResult doOpenXUIPopup(
			IClientContext context, String message, String title,
			JLbsStringList list, int buttons)
	{
		ILbsCultureInfo culture = (ILbsCultureInfo) context
				.getVariable(JLbsConstants.ms_VarCultureInfo);
		if (culture == null)
			culture = new JLbsDefaultCultureInfo();

		JLbsCurrenciesBase currencies = (JLbsCurrenciesBase) context
				.getVariable(JLbsConstants.ms_VarCurrencies);
		if (currencies == null)
		{
			currencies = new JLbsCurrenciesBase();
			currencies.setDefaultCurrency(JLbsCurrencyInfo.CI_EURO);
		}
		JLbsMessageDialog dialog = new JLbsMessageDialog(null, message, list,
				title, buttons, culture, buttons);
		dialog.setVisible(true);
		JLbsMessageDialogResult result = new JLbsMessageDialogResult();
		result.button = dialog.getButtonClicked();
		result.message = dialog.getMessageSelected();
		return result; // JLbsMessageDialog.BUT_OK, BUT_CANCEL
	}

	public static void updateComponentData(JLbsXUIPane container, int tag)
	{
		try
		{
			container.getControlByTag(tag).updateComponentValueBound();
		} catch (Exception e)
		{
		}
	}

	public static boolean checkForComboClear(JLbsXUIControlEvent event,
			String linkRefProp, String linkProp, int ctrlTag)
	{
		try
		{
			if (event.getKeyCode() == KeyEvent.VK_BACK_SPACE)
				try
				{
					CustomBusinessObject data = (CustomBusinessObject) event.getData();
					if (linkRefProp != null)
						ProjectUtil.setMemberValue(data, linkRefProp, new Integer(0));
					if (linkProp != null)
						ProjectUtil.setMemberValue(data, linkProp, null);
					FormUtil.updateComponentData(event.getContainer(), ctrlTag);
				} catch (Exception e)
				{
				}
			return true;
		} catch (Exception e)
		{
		}
		return false;
	}

	public static Object getQueryParamValue(JLbsXUIControlEvent event,
			String paramName)
	{
		try
		{
			JLbsXUILookupInfo lookup = (JLbsXUILookupInfo) event.getData();
			return lookup.getQueryParamValue(paramName);
			
		} catch (Exception e)
		{
		}
		return null;
	}

	public static int getQueryParamInt(JLbsXUIControlEvent event,
			String paramName, int defVal)
	{
		Object o = getQueryParamValue(event, paramName);
		if (o instanceof Integer)
			return ((Integer) o).intValue();
		return defVal;
	}

	public static String getQueryParamString(JLbsXUIControlEvent event,
			String paramName, String defVal)
	{
		Object o = getQueryParamValue(event, paramName);
		if (o instanceof String)
			return (String) o;
		return defVal;
	}

	public static boolean isNewObject(JLbsXUIControlEvent event)
	{
		try
		{
			CustomBusinessObject bo = (CustomBusinessObject) event.getData();
			Object value = bo.get("LOGICALREF");
			if (value == null || (value instanceof Integer && ((Integer) value).intValue() == 0))
				return true;
		} catch (Exception e)
		{
		}
		return false;
	}

	public static void setDataProperty(JLbsXUIControlEvent event, String string, Object value)
	{		
		try
		{
			CustomBusinessObject bo = (CustomBusinessObject) event.getData();
			bo.set(string, value);
		} catch (Exception e)
		{
		}
	}
	
	public static CustomBusinessObject createCustomObject(String typeName)
	{
		CustomBusinessObject result = new CustomBusinessObject(ProjectGlobals.getProjectGUID(), typeName);
		return result;
	}
}
