package com.logopartner.util;

import java.util.Calendar;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Set;

import com.lbs.appobjects.LbsUserLoginInfo;
import com.lbs.data.factory.FactoryParams;
import com.lbs.data.factory.IObjectFactory;
import com.lbs.data.objects.BasicBusinessObject;
import com.lbs.data.objects.BusinessObject;
import com.lbs.data.objects.CustomBusinessObject;
import com.lbs.data.objects.CustomBusinessObjects;
import com.lbs.data.objects.ObjectValueManager;
import com.lbs.data.query.QueryBusinessObject;
import com.lbs.data.query.QueryBusinessObjects;
import com.lbs.data.query.QueryParams;
import com.lbs.grids.JLbsObjectListGrid;
import com.lbs.invoke.MethodInvoker;
import com.lbs.invoke.RttiUtil;
import com.lbs.remoteclient.IClientContext;
import com.lbs.util.JLbsStringList;
import com.lbs.util.JLbsStringListItemEx;
import com.lbs.xui.JLbsXUIControl;
import com.lbs.xui.JLbsXUILookupInfo;
import com.lbs.xui.JLbsXUIPane;
import com.lbs.xui.customization.JLbsXUIControlEvent;
import com.lbs.xui.customization.JLbsXUIEventBase;
import com.lbs.xui.customization.JLbsXUIGridEvent;

public class ProjectUtil
{
	public static final String ms_UserInfo = "UserLoginInfo";

	private static Hashtable applicationClasses = null;

	public static void checkSubLink(CustomBusinessObject myExt,
			String linkName, String linkCBOName)
	{
		CustomBusinessObjects linkLines = (CustomBusinessObjects) ProjectUtil
				.getMemberValue(myExt, linkName);
		if (linkLines == null)
		{
			linkLines = new CustomBusinessObjects();
			ProjectUtil.setMemberValue(myExt, linkName, linkLines);
		}
		if (linkLines != null && linkLines.size() == 0)
		{
			CustomBusinessObject emptyCompLine = ProjectUtil
					.createNewCBO(linkCBOName);
			linkLines.add(emptyCompLine);
		}
	}

	public static void setMemberValue(CustomBusinessObject lineObj,
			String memberName, Object value)
	{
		try
		{
			ObjectValueManager.setGridMemberValue(lineObj, memberName, value,
					false);
		} catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void setMemberValueUn(CustomBusinessObject lineObj,
			String memberName, Object value)
	{
		try
		{
			ObjectValueManager.setMemberValue(lineObj, memberName, value);

		} catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static Object getMemberValue(CustomBusinessObject lineObj,
			String memberName)
	{
		try
		{
			return ObjectValueManager.getMemberValue(lineObj, memberName);
		} catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	public static QueryBusinessObjects runQuery(JLbsXUIEventBase event,
			String queryName, String[] paramNames, Object[] paramVals,
			String[] enabledTerms, String[] disabledTerms)
	{
		if (paramNames == null || paramVals == null
				|| paramNames.length != paramNames.length)
			return null;

		IClientContext context = event.getContainer().getContext();
		QueryParams params = new QueryParams();

		if (enabledTerms != null && enabledTerms.length > 0)
			for (int i = 0; i < enabledTerms.length; i++)
				params.getEnabledTerms().enable(enabledTerms[i]);

		if (disabledTerms != null && disabledTerms.length > 0)
			for (int i = 0; i < disabledTerms.length; i++)
				params.getEnabledTerms().disable(disabledTerms[i]);

		QueryBusinessObjects items = new QueryBusinessObjects();
		try
		{
			for (int i = 0; i < paramNames.length; i++)
				params.getParameters().put(paramNames[i], paramVals[i]);

			params.setCustomization(ProjectGlobals.getProjectGUID());
			boolean ok = context.getQueryFactory().first(queryName, params,
					items, -1, false);

			if (ok && items.size() > 0)
				return items;
		} catch (Exception e)
		{
			e.printStackTrace();

		}

		return null;
	}

	public static QueryBusinessObjects runQuery(JLbsXUIEventBase event,
			String queryName, String[] paramNames, Object[] paramVals)
	{
		return runQuery(event, queryName, paramNames, paramVals, null, null);
	}

	public static QueryBusinessObject runSingleLineQuery(
			JLbsXUIEventBase event, String queryName, String[] paramNames,
			Object[] paramVals, String[] enabledTerms, String[] disabledTerms)
	{
		QueryBusinessObjects lines = runQuery(event, queryName, paramNames,
				paramVals);
		if (lines != null && lines.size() > 0)
			return (QueryBusinessObject) lines.elementAt(0);
		return null;
	}

	public static QueryBusinessObject runSingleLineQuery(
			JLbsXUIEventBase event, String queryName, String[] paramNames,
			Object[] paramVals)
	{
		return runSingleLineQuery(event, queryName, paramNames, paramVals,
				null, null);
	}

	public static Object getContextVar(JLbsXUIControlEvent event, String varName)
	{
		IClientContext context = event.getClientContext();
		return context.getVariable(varName);
	}

	public static void setContextVar(JLbsXUIControlEvent event, String varName,
			Object value)
	{
		IClientContext context = event.getClientContext();
		context.setVariable(varName, value);
	}

	public static void warn(JLbsXUIEventBase event, String msg)
	{
		JLbsXUIPane container = event.getContainer();
		container.messageDialog(msg, null);
	}

	public static void warn(JLbsXUIEventBase event, String msg,
			JLbsStringList list)
	{
		JLbsXUIPane container = event.getContainer();
		container.messageDialog(msg, list);
	}

	public static CustomBusinessObject readObject(JLbsXUIControlEvent event,
			String BOName, int BORef)
	{
		JLbsXUIPane container = event.getContainer();
		IClientContext context = container.getContext();
		IObjectFactory objFactory = context.getObjectFactory();
		CustomBusinessObject CBO = new CustomBusinessObject(BOName);
		CBO.setCustomization(ProjectGlobals.getProjectGUID());
		FactoryParams params = new FactoryParams();
		params.setCustomization(ProjectGlobals.getProjectGUID());
		try
		{
			boolean ok = objFactory.read(CBO, params, BORef);
			if (ok)
				return CBO;
		} catch (Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}

	public static Object getGridCellValue(JLbsXUIGridEvent event, int gridTag)
	{
		JLbsXUIPane container = event.getContainer();
		container.messageDialog("GridtAG : " + gridTag, null);
		JLbsXUIControl cGrid = container.getControlByTag(gridTag);
		container.messageDialog("cccgrid : " + cGrid, null);
		return cGrid != null ? cGrid.getEditedCellValue() : null;
	}

	public static CustomBusinessObject readObjectGrid(JLbsXUIGridEvent event,
			String BOName, int BORef)
	{
		JLbsXUIPane container = event.getContainer();
		IClientContext context = container.getContext();
		IObjectFactory objFactory = context.getObjectFactory();
		CustomBusinessObject CBO = new CustomBusinessObject(BOName);
		CBO.setCustomization(ProjectGlobals.getProjectGUID());
		FactoryParams params = new FactoryParams();
		params.setCustomization(ProjectGlobals.getProjectGUID());
		try
		{
			boolean ok = objFactory.read(CBO, params, BORef);
			if (ok)
				return CBO;
		} catch (Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}

	protected static String addStr(String msg, String s)
	{
		if (msg == null)
			return s;
		else
			return msg + "\n" + s;
	}

	public static void showFormParameters(JLbsXUIControlEvent event)
	{
		JLbsXUIPane container = event.getContainer();

		Object data = container.getData();
		JLbsStringList list = new JLbsStringList();

		if (data == null)
			warn(event, "Form data is null!");
		else if (data instanceof JLbsXUILookupInfo)
		{
			list.add("Form data type is JLbsXUILookupInfo");

			JLbsXUILookupInfo info = (JLbsXUILookupInfo) data;
			if (info.getParameters() != null)
			{
				list.add("");
				list.add("Parameters:");
				HashMap map = info.getParameters();
				Set s = map.keySet();
				Iterator itr = s.iterator();
				while (itr.hasNext())
				{
					String itemName = null;
					Object obj = itr.next();
					if (obj != null)
						itemName = obj.toString();
					if (itemName != null)
						list.add("  " + itemName + ", value: "
								+ info.getParameter(itemName));
				}
			}

			if (info.getQueryParamCount() > 0)
			{
				list.add("");
				list.add("Query parameters:");

				for (int i = 0; i < info.getQueryParamCount(); i++)
					list.add("  " + info.getQueryParam(i) + ", value: "
							+ info.getQueryParamValue(i));
			}
			if (info.getQueryParamCount() > 0)
			{
				list.add("");
				list.add("Query variables:");

				for (int i = 0; i < info.getQueryVariableCount(); i++)
					list.add("  " + info.getQueryVariable(i) + ", value: "
							+ info.getQueryVariableValue(i));
			}
			warn(event, "Form data:", list);
		} else
		{
			warn(event, "Form data: " + data.toString());
		}
	}

	public static Object getBOFieldValue(Object bo, String fieldName)
	{
		BusinessObject bObject = (BusinessObject) bo;
		if (bObject != null)
		{
			try
			{
				Object retObj = RttiUtil.getProperty(bObject, fieldName);
				return retObj;
			} catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		return null;
	}

	public static int getBOIntFieldValue(Object bo, String fieldName)
	{
		Object o = getBOFieldValue(bo, fieldName);

		return o == null ? 0 : ((Integer) o).intValue();
	}

	public static String getBOStringFieldValue(Object bo, String fieldName)
	{
		Object o = getBOFieldValue(bo, fieldName);
		if (o != null)
		{
			String s = (String) o;
			return s;
		}
		return null;
	}

	public static Calendar getBODateFieldValue(Object bo, String fieldName)
	{
		Object o = getBOFieldValue(bo, fieldName);
		if (o != null)
		{
			Calendar c = (Calendar) o;
			return c;
		}
		return null;
	}

	public static CustomBusinessObject createNewCBO(String CBOName)
	{
		CustomBusinessObject CBO = new CustomBusinessObject(CBOName);
		CBO.setCustomization(ProjectGlobals.getProjectGUID());

		return CBO;
	}

	public static CustomBusinessObject checkAndCreateNewCBO(
			BasicBusinessObject BO, String CBOName)
	{
		CustomBusinessObject editCBO = (CustomBusinessObject) BO
				.getExtensions().get(CBOName);
		if (editCBO == null)
		{
			editCBO = ProjectUtil.createNewCBO(CBOName);
			BO.getExtensions().add(editCBO);
		}
		return editCBO;
	}

	public static CustomBusinessObject getCBO(BasicBusinessObject BO,
			String CBOName)
	{
		CustomBusinessObject editCBO = (CustomBusinessObject) BO
				.getExtensions().get(CBOName);
		return editCBO;
	}

	public static void checkAndCreateLinkedObjects(BusinessObject BO)
	{
		BO.getInitialValues().setEnabled(false);
		BO.createLinkedObjects();
		BO.getInitialValues().setEnabled(true);
	}

	public static void insertNewLine(JLbsXUIEventBase event,
			CustomBusinessObjects lines, String lineCBOName)
	{
		CustomBusinessObject newLine = ProjectUtil.createNewCBO(lineCBOName);
		lines.add(newLine);
	}

	public static void insertNewLineToGrid(JLbsXUIEventBase event,
			JLbsObjectListGrid objGrid, String lineCBOName)
	{
		try
		{
			CustomBusinessObjects lines = (CustomBusinessObjects) objGrid
					.getObjects();
			System.out.println("** objGrid.getObjects():"
					+ objGrid.getObjects().getClass());

			insertNewLine(event, lines, lineCBOName);
			objGrid.rowListChanged();
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public static void deleteGridRow(JLbsXUIEventBase event,
			JLbsObjectListGrid objGrid, int lineNr)
	{
		try
		{
			CustomBusinessObjects lines = (CustomBusinessObjects) objGrid
					.getObjects();
			if (lines.size() > 0 && lineNr < lines.size() && lineNr >= 0)
			{
				lines.delete(lineNr);
				objGrid.rowListChanged();
			}
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public static boolean eventGridTagIs(JLbsXUIGridEvent event, int gridTag)
	{
		JLbsXUIPane container = event.getContainer();
		JLbsObjectListGrid grid = (JLbsObjectListGrid) container
				.getComponentByTag(gridTag);
		JLbsObjectListGrid objGrid = (JLbsObjectListGrid) event.getGrid();
		return grid == objGrid;
	}

	public static int getCompanyNumber(IClientContext context)
	{
		LbsUserLoginInfo userLoginInfo;
		userLoginInfo = (LbsUserLoginInfo) context.getVariable(ms_UserInfo);
		return userLoginInfo.getFirm().getNr();
	}

	public static String getCompanyName(IClientContext context)
	{
		LbsUserLoginInfo userLoginInfo;
		userLoginInfo = (LbsUserLoginInfo) context.getVariable(ms_UserInfo);
		return userLoginInfo.getFirm().getName();
	}

	public static int getUserNr(IClientContext context)
	{
		LbsUserLoginInfo userLoginInfo;
		userLoginInfo = (LbsUserLoginInfo) context.getVariable(ms_UserInfo);
		return userLoginInfo.getUser().getNr();
	}

	public static int getUserLRef(IClientContext context)
	{
		LbsUserLoginInfo userLoginInfo;
		userLoginInfo = (LbsUserLoginInfo) context.getVariable(ms_UserInfo);
		return userLoginInfo.getUser().getLogicalRef();
	}

	public static Object callAppMethod(IClientContext context,
			String className, String methodName, Object[] parameters)
	{
		// * @author AyhanI
		// * @version 1.0

		Object o = null;
		try
		{
			if (applicationClasses == null)
				applicationClasses = new Hashtable();

			o = applicationClasses.get(className);
			if (o == null)
			{
				o = context.createInstance(className);
				applicationClasses.put(className, o);
			}
		} catch (Exception e)
		{
			e.printStackTrace();
		}
		if (o != null)
			return MethodInvoker.invokeMethodSafe(methodName, o, parameters);
		return null;
	}

	public static void dumpEventParams(JLbsXUIControlEvent event)
	{
		System.out.println("Dumping event params");
		System.out.println("CtxData " + event.getCtxData());
		System.out.println("Tag " + event.getTag());
		System.out.println("Id " + event.getId());
		System.out.println("Index " + event.getIndex());
		System.out.println("ItemMask " + event.getItemMask());
		System.out.println("StringData " + event.getStringData());
	}

	public static boolean persistCBO(JLbsXUIControlEvent event,
			CustomBusinessObject CBO)
	{
		JLbsXUIPane container = event.getContainer();
		IClientContext context = container.getContext();
		IObjectFactory objFactory = context.getObjectFactory();
		FactoryParams params = new FactoryParams();
		params.setCustomization(ProjectGlobals.getProjectGUID());
		try
		{
			objFactory.persist(CBO, params);
		} catch (Exception e)
		{
			// TODO: handle exception
			return false;
		}
		return true;
	}

	public static BusinessObject createBOInstance(IClientContext context,
			String BOName)
	{
		BusinessObject newBO;
		try
		{
			newBO = (BusinessObject) context.createInstance(BOName);
		} catch (Exception e)
		{
			newBO = null;
			e.printStackTrace();
		}
		return newBO;
	}

	public static BusinessObject createBOInstance(JLbsXUIControlEvent event,
			String BOName)
	{
		return createBOInstance(event.getContainer().getContext(), BOName);
	}

	public static BusinessObject createBOInstance(JLbsXUIGridEvent event,
			String BOName)
	{
		return createBOInstance(event.getContainer().getContext(), BOName);
	}

	public static Object callAppMethod(IClientContext context,
			String methodName, Object[] parameters)
	{
		Object o = null;
		String className = "com.lbs.unity.UnityCustomizationHelper";
		try
		{
			if (applicationClasses == null)
				applicationClasses = new Hashtable();

			o = applicationClasses.get(className);
			if (o == null)
			{
				o = context.createInstance(className);
				applicationClasses.put(className, o);
			}
		} catch (Exception e)
		{
			e.printStackTrace();
		}
		if (o != null)
			return MethodInvoker.invokeMethodSafe(methodName, o, parameters);
		return null;
	}

	public static JLbsStringListItemEx[] formListArray(String[] paramNames,
			Object[] items)
	{
		if (items != null && paramNames != null
				&& items.length == paramNames.length)
		{
			JLbsStringListItemEx[] array = new JLbsStringListItemEx[items.length];
			for (int i = 0; i < items.length; i++)
				array[i] = new JLbsStringListItemEx(paramNames[i], i, items[i]);
			return array;
		}
		return null;
	}

}
